
class CharStack {
    // Instance variables
    protected char[] stackArray;  // The array that implements the stack.

    protected int topOfStack;     // The top of the stack.

    // Static variable
    private static int counter;                                      

    // Constructor now increments the counter for each object created.
    public CharStack(int capacity) {                                 
        stackArray = new char[capacity];
        topOfStack = -1;
        counter++;
    }

    // Instance methods
    public void push(char element) { stackArray[++topOfStack] = element; }
    public char pop() { return stackArray[topOfStack--]; }
    public char peek() { return stackArray[topOfStack]; }
    public boolean isEmpty() { return topOfStack < 0; }
    public boolean isFull() { return topOfStack >= stackArray.length; }

    // Static method                                                    
    public static int getInstanceCount() { return counter; }
}

class PrintableCharStack extends CharStack {                          // (1) 
    // Instance method
    public void printStackElements() {                                // (2)
        for (int i= 0; i < stackArray.length; i++)
            System.out.print(stackArray[i]); // print each char on terminal
        System.out.println();
    }
    // Constructor calls the constructor of the superclass explicitly.
    public PrintableCharStack(int capacity) { super(capacity); }      // (3)
}
