
// Example of a standalone application
// Source Filename: Client.java

public class Client {

    public static void main(String args[]) {

        // Create a stack
        CharStack stack = new CharStack(40);

        // Create a string to push on the stack
        String str = "!no tis ot nuf era skcatS";
        int length = str.length();

        // Push the string char by char onto the stack
        for (int i = 0; i<length; i++) {
            stack.push(str.charAt(i));
        }

        // Pop and print each char from the stack
        while (!stack.isEmpty()) {
            System.out.print(stack.pop());
        }
        System.out.println();
    }
}

class CharStack {
    // Instance variables
    private char[] stackArray;  // The array that implements the stack.
    private int topOfStack;     // The top of the stack.

    // Static variable
    private static int counter;                                      // (1)

    // Constructor now increments the counter for each object created.
    public CharStack(int capacity) {                                 // (2)
        stackArray = new char[capacity];
        topOfStack = -1;
        counter++;
    }

    // Instance methods
    public void push(char element) { stackArray[++topOfStack] = element; }
    public char pop() { return stackArray[topOfStack--]; }
    public char peek() { return stackArray[topOfStack]; }
    public boolean isEmpty() { return topOfStack < 0; }
    public boolean isFull() { return topOfStack >= stackArray.length; }

    // Static method                                                    (3)
    public static int getInstanceCount() { return counter; }
}
