
// Source Filename: ClientApplet.java

import java.applet.Applet;   // Import the Applet class
import java.awt.Graphics;    // Import the Graphics class

// An applet must extend the Applet class
public class ClientApplet extends Applet { // (1)

    // Instance variables
    CharStack stack;
    String originalStr;
    String reversedStr;

    // Instance methods
    public void init() {                   // (2) Called when the applet is loaded.

        // Create a stack
        stack = new CharStack(40);

        // Create a string to push on the stack
        originalStr = new String("!no tis ot nuf era skcatS");
        int length = originalStr.length();

        // Push the string char by char onto the stack
        for (int i = 0; i<length; i++) {
            stack.push(originalStr.charAt(i));
        }

        // Pop and store each char from the stack into a new string
        reversedStr = new String();        // Empty new string
        while (!stack.isEmpty()) {
            reversedStr += stack.pop();    // Concatenate characters
        }
    }

    public void paint(Graphics gfx) {      // (3) Called to draw the applet.
        // A Graphics object is used to render graphics in an applet.
        // Draw the reversed string at the specified coordinates.
        gfx.drawString(reversedStr, 25, 25);
    }
}

class CharStack {
    // Instance variables
    private char[] stackArray;  // The array that implements the stack.
    private int topOfStack;     // The top of the stack.

    // Static variable
    private static int counter;                                      

    // Constructor now increments the counter for each object created.
    public CharStack(int capacity) {                                 
        stackArray = new char[capacity];
        topOfStack = -1;
        counter++;
    }

    // Instance methods
    public void push(char element) { stackArray[++topOfStack] = element; }
    public char pop() { return stackArray[topOfStack--]; }
    public char peek() { return stackArray[topOfStack]; }
    public boolean isEmpty() { return topOfStack < 0; }
    public boolean isFull() { return topOfStack >= stackArray.length; }

    // Static method                                                    
    public static int getInstanceCount() { return counter; }
}
