
import java.util.*;

public class CharacterSets {
    public static void main(String args[]) {
        int nArgs = args.length;

        // A set keeping track of all characters previously encountered.
        Set encountered = new HashSet();                              // (1)

        // For each command line argument...
        for (int i=0; i<nArgs; i++) {
            String argument = args[i];

            // Convert string to a set of characters.
            Set characters = new HashSet();                           // (2)
            int size = argument.length();

            // For each character in the argument...
            for (int j=0; j<size; j++)
                // append character.
                characters.add(new Character(argument.charAt(j)));    // (3)

            // Determine if there exists a common subset.                (4)
            Set commonSubset = new HashSet(encountered);
            commonSubset.retainAll(characters);
            boolean areDisjunct = commonSubset.size()==0;

            if (areDisjunct)
                System.out.println(characters + " and " + encountered +
                    " are disjunct.");
            else {
                // Determine superset and subset relations.              (5)
                boolean isSubset = encountered.containsAll(characters);
                boolean isSuperset = characters.containsAll(encountered);
                if (isSubset && isSuperset)
                    System.out.println(characters + " is equivalent to " +
                        encountered);
                else if (isSubset)
                    System.out.println(characters + " is a subset of " +
                        encountered);
                else if (isSuperset)
                    System.out.println(characters + " is a superset of " +
                        encountered);
                else
                    System.out.println(characters + " and " +
                        encountered + " have " + commonSubset + " in common.");
            }

            // Remember the characters encountered.
            encountered.addAll(characters);                     // (6)
        }
    }
}
