
import java.util.*;

public class TakeAGuess {
    final static int N_DIGITS = 5;

    public static void main(String args[]) {
        // Sanity check on the given data.
        if (args.length != N_DIGITS) {
            System.err.println("Guess " + N_DIGITS + " digits.");
            return;
        }

        /* Initializes the solution list. This program has a fixed solution. */
        List secretSolution = new ArrayList();                      // (1)
        secretSolution.add("5");
        secretSolution.add("3");
        secretSolution.add("2");
        secretSolution.add("7");
        secretSolution.add("2");

        // Converts the user's guess from string array to list.        (2)
        List guess = new ArrayList();
        for (int i=0; i<N_DIGITS; i++)
            guess.add(args[i]);

        // Find the number of digits that were correctly included.     (3)
        List duplicate = new ArrayList(secretSolution);
        int nIncluded = 0;
        for (int i=0; i<N_DIGITS; i++)
            if (duplicate.remove(guess.get(i))) ++nIncluded;

        /* Find the number of correctly placed digits by comparing the two
           lists, element for element, counting each correct placement. */
        int nPlaced = 0;
        // Need two iterators to iterate through guess and solution.   (4)
        ListIterator correct = secretSolution.listIterator();
        ListIterator attempt = guess.listIterator();
        while (correct.hasNext())
            if (correct.next().equals(attempt.next())) nPlaced++;

        // Print results.
        System.out.println(nIncluded + " digit(s) correctly included.");
        System.out.println(nPlaced +   " digit(s) correctly placed.");
    }
}
