
import java.awt.*;
import java.applet.*;

public class CardLayoutApplet extends Applet implements Runnable {

    // Arrays of card names and their corresponding color.
    String[] cardNames = {"En", "To", "Tre", "Fire", "Fem"};
    Color[]  colors    = {Color.green, Color.pink, Color.white,
                          Color.blue, Color.yellow};

    // Create a CardLayout object
    CardLayout layout = new CardLayout();                              // (1)

    public void init() {                                               // (2)

        // Set the CardLayout as the layout manager
        setLayout(layout);

        // Add buttons to the container
        for (int i = 0; i < cardNames.length; i++) {

            // Create a new button with name
            Button displayButton = new Button(cardNames[i]);

            // Set the background color and (increasing) font size
            displayButton.setBackground(colors[i]);
            displayButton.setFont(new Font("Serif", Font.BOLD, 14 + (4*i)));

            // Add button with its identification name
            add(displayButton, cardNames[i]);                          // (3)
        }
    }

    Thread animation;
    public void start() {                                             // (4)
        // Create and start a thread if none present.
        if (animation == null) {
            animation = new Thread(this);
            animation.start();
        }
    }

    public void stop() {                                              // (5)
        animation = null;
    }

    public void run() {                                               // (6)
        layout.show(this, cardNames[0]); // Show card "En"               (7)
        showStatus("No. 1"); // Let the applet context show the string.
        try {
            // Cycle through the rest of the cards
            for (int i = 1; i < cardNames.length; i++) {
                Thread.sleep(1000);
                if (animation != Thread.currentThread()) break;

                layout.next(this);                                    // (8)
                showStatus("No. " + (i+1));
            }
        } catch(InterruptedException e) {}
    }
}
