import java.awt.*;
import java.applet.*;

public class GridBagLayoutApplet extends Applet {

    public void init() {

        // Create a list of colors
        String[] colors = {"Black", "Blue", "Green", "Red", "Yellow"};
        List colorList = new List(colors.length -2, false);
        for (int i=0; i<colors.length; i++)
            colorList.add(colors[i]);

        // Create a label
        Label shape = new Label("Shape:");
        shape.setFont(new Font("Serif", Font.BOLD, 14));

        // Create a choice list
        Choice shapeChoice = new Choice();
        shapeChoice.add("Square");
        shapeChoice.add("Circle");
        shapeChoice.add("Ellipse");

        // Create a checkbox
        Checkbox cbFill = new Checkbox("Fill", false);
        cbFill.setFont(new Font("Serif", Font.BOLD, 14));

        // Create and set the GridBagLayout
        setLayout(new GridBagLayout());

        // Create a GridBagConstraints object
        GridBagConstraints gbc = new GridBagConstraints();        // (1)

        /*
           Set the "global" constraints.                             (2)
           Each component will not fill and is anchored in the top left corner.
           The area allocated to each component will grow in the horizontal
           direction, but not in the vertical direction.
        */
        gbc.fill    = GridBagConstraints.NONE;
        gbc.anchor  = GridBagConstraints.NORTHWEST;
        gbc.weightx = 1;
        gbc.weighty = 0;

        // Add the components using the constraints               // (3)
        addUsingGBL(colorList,   gbc, 0, 0, 1, 3);
        addUsingGBL(shape,       gbc, 1, 0, 1, 2);
        addUsingGBL(shapeChoice, gbc, 2, 0, 1, 2);
        addUsingGBL(cbFill,      gbc, 1, 2, 2, 1);
    }

    void addUsingGBL(Component component, GridBagConstraints gbc,
                     int x, int y, int w, int h) {                // (4)
        gbc.gridx      = x;
        gbc.gridy      = y;
        gbc.gridwidth  = w;
        gbc.gridheight = h;
        add(component, gbc);                                      // (5)
   }
}
