
import java.awt.*;
import java.applet.*;

/**
    Demo of Component Hierarchy
*/
public class GUILayoutApplet extends Applet {
    // Panel for shape
    Panel shapePanel;
    CheckboxGroup shapeCBG;
    Checkbox      squareCB;
    Checkbox      circleCB;
    Checkbox      ellipseCB;

    // Panel for x,y coordinates
    Panel     xyPanel;
    Label     xLabel;
    TextField xInput;
    Label     yLabel;
    TextField yInput;

    // Panel for size and fill
    Panel    sizePanel;
    Label    sizeLabel;
    Choice   sizeChoice;
    Checkbox fillCB;

    // Panel for shape, coordinates, size and fill
    Panel leftPanel;

    // Panel for Message display, draw button and canvas
    Panel     rightPanel;
    Button    drawButton;
    Canvas    drawRegion;
    TextField msg;

    public void init() {
        makeShapePanel();
        makeXYPanel();
        makeSizePanel();
        makeLeftPanel();
        makeRightPanel();

        add(leftPanel);
        add(rightPanel);
    }

    // Panel for shape
    private void makeShapePanel() {
        shapePanel = new Panel();

        shapeCBG   = new CheckboxGroup();

        squareCB   = new Checkbox("Square",  shapeCBG, true);
        circleCB   = new Checkbox("Circle",  shapeCBG, false);
        ellipseCB  = new Checkbox("Ellipse", shapeCBG, false);

        shapePanel.setLayout(new FlowLayout());
        shapePanel.add(squareCB);
        shapePanel.add(circleCB);
        shapePanel.add(ellipseCB);
    }

    // Panel for x,y coordinates
    private void makeXYPanel() {
        xyPanel = new Panel();

        xLabel  = new Label("X Coordinate:");
        yLabel  = new Label("Y Coordinate:");

        xInput  = new TextField(5);
        yInput  = new TextField(5);

        xyPanel.setLayout(new GridLayout(2,2));
        xyPanel.add(xLabel);
        xyPanel.add(xInput);
        xyPanel.add(yLabel);
        xyPanel.add(yInput);
    }

    // Panel for size and fill
    private void makeSizePanel() {
        sizePanel  = new Panel();

        sizeLabel  = new Label("Size:");

        sizeChoice = new Choice();
        sizeChoice.add("Large");
        sizeChoice.add("Medium");
        sizeChoice.add("Small");

        fillCB = new Checkbox("Fill", false);

        sizePanel.setLayout(new FlowLayout());
        sizePanel.add(sizeLabel);
        sizePanel.add(sizeChoice);
        sizePanel.add(fillCB);
    }

    // Panel for shape, coordinates, size and fill
    private void makeLeftPanel() {
        leftPanel = new Panel();

        leftPanel.setLayout(new BorderLayout());
        leftPanel.add(shapePanel, BorderLayout.NORTH);
        leftPanel.add(xyPanel,    BorderLayout.CENTER);
        leftPanel.add(sizePanel,  BorderLayout.SOUTH);
    }

    // Panel for Message display, draw button, and canvas
    private void makeRightPanel() {
        rightPanel = new Panel();

        msg = new TextField("MESSAGE DISPLAY");
        msg.setEditable(false);
        msg.setBackground(Color.yellow);

        drawButton = new Button("Draw");
        drawButton.setBackground(Color.lightGray);

        drawRegion = new Canvas();
        drawRegion.setSize(150,150);
        drawRegion.setBackground(Color.white);

        rightPanel.setLayout(new BorderLayout());
        rightPanel.add(drawButton, BorderLayout.NORTH);
        rightPanel.add(msg,        BorderLayout.SOUTH);
        rightPanel.add(drawRegion, BorderLayout.CENTER);
    }
}
