/*
   SimpleWindowThree: A simple setup for Event Delegation Model
   using Anonymous Classes.
 */
import java.awt.*;
import java.awt.event.*;

public class SimpleWindowThree extends Frame {

    Button quitButton;

    public SimpleWindowThree() {

        // Create a window
        super("SimpleWindowThree");

        // Create one button
        quitButton = new Button("Quit");

        // Set a layout manager, and add the button to the window.
        setLayout(new FlowLayout(FlowLayout.CENTER));
        add(quitButton);

        // Create and add the listener to the button
        quitButton.addActionListener(new ActionListener() {     // (1)
            // Invoked when the user clicks the quit button.
            public void actionPerformed(ActionEvent evt) {
                if (evt.getSource() == quitButton)
                    terminate();                                // (2)
            }
        });

        // Create and add the listener to the window
        addWindowListener(new WindowAdapter() {                 // (3)
            // Invoked when the user clicks the close-box.
            public void windowClosing(WindowEvent evt) {
                terminate();                                    // (4)
            }
        });

        // Pack the window and pop it up.
        pack();
        setVisible(true);
    }

    private void terminate() {
        System.out.println("Quitting the application.");
        dispose();
        System.exit(0);
    }

    /** Create an instance of the application */
    public static void main(String args[]) { new SimpleWindowThree(); }

}
