import java.applet.*;
import java.awt.*;

public class BufferingApplet extends Applet {

    private Image bufferImage;
    private Graphics imageGfx;

    private Color color1 = Color.gray;
    private Color color2 = Color.black;

    public void init() {
        // Create an image                                                 (1)
        bufferImage = createImage(getSize().width, getSize().height);
        // Get the graphics context associated with the image
        imageGfx = bufferImage.getGraphics();                           // (2)
    }

    public void paint(Graphics gfx) {                                   // (3)
        // Swap colors
        Color temp = color2;
        color2 = color1;
        color1 = temp;

        // Clear buffer image                                              (4)
        imageGfx.setColor(getBackground());
        imageGfx.fillRect(0,0, getSize().width, getSize().height);
        // Render graphics in the buffer image
        imageGfx.setColor(color1);
        imageGfx.fillArc(20, 0,       // top left-hand corner              (5)
                         50, 50,      // width, height
                         30, 300);    // start angle, sweep angle
        imageGfx.setColor(color2);
        imageGfx.drawString("Come and play!", 0, 60);
        // Display the buffer image, passing applet as the ImageObserver.
        gfx.drawImage(bufferImage, 50, 20, this);                       // (6)
    }

    // Override update to reduce flickering
    public void update(Graphics gfx) {                                  // (7)
        paint(gfx);
    }
}
