
// Font Metrics Demo: Box round a string
import java.applet.*;
import java.awt.*;

public class FontMetricsApplet extends Applet {

    public void init() {                                     // (1)
        setForeground(Color.black);
        setBackground(new Color(0.444f, 0.502f, 1.0f));
    }

    public void paint(Graphics g) {                          // (2)
        // Create and set the font                              (3)
        Font font = new Font("Serif", Font.BOLD, 18);
        g.setFont(font);

        // Translate the origin                                 (4)
        g.translate(getInsets().left, getInsets().top);

        // Draw a string                                        (5)
        String str = "Put me in a big box!";
        g.drawString(str, 50, 50);

        // Get the font metrics for the font                    (6)
        FontMetrics metrics = g.getFontMetrics(font);
        // Find the maximum ascent for all characters in the font.
        int maxAscent = metrics.getMaxAscent();
        // Find the maximum descent for all characters in the font.
        int maxDescent = metrics.getMaxDescent();
        // Find the width of the string
        int stringWidth = metrics.stringWidth(str);
        // Draw box round the string
        g.drawRect(50, 50- maxAscent,               // top left-hand corner
                   stringWidth,                     // width of the box
                   maxAscent + maxDescent);         // height of the box
    }
}
