
// Demo for Applet Parameters
import java.applet.*;
import java.awt.*;

public class AppletParams extends Applet {

    public void init() {
        // Read two color parameters
        Color foreground = getColorParam("foreground");
        Color background = getColorParam("background");
        // Set the colors.
        if (foreground != null) setForeground(foreground);
        if (background != null) setBackground(background);
    }

    private Color getColorParam(String paramName) {
        // Read parameter value as string
        String paramValue = getParameter(paramName);               // (1)

        try { // Convert to hex integer value
            return new Color(Integer.parseInt(paramValue, 16));    // (2)
        } catch (NumberFormatException e) { return null; }
    }

    public void paint(Graphics gfx) {
        gfx.translate(getInsets().left, getInsets().top);
        gfx.drawString("I love my new colors!", 50, 50);
    }

    // Provide info for display in a dialog box
    public String getAppletInfo() {                                // (3)
        return "AppletParams 1.0 written by KAM";
    }

    // Provide info about applet parameters
    public String[][] getParameterInfo() { return paramInfo; }     // (4)

    private String[][] paramInfo = {
        // Parameter name, Parameter type, Parameter description
        {"foreground", "Hex RGB color value", "Foreground color"},
        {"background", "Hex RGB color value", "Background color"}
    };
}
