// Retrieving and playing sound
import java.applet.*;
import java.awt.*;

public class SoundApplet extends Applet {

    AudioClip audioClip;
    String msg = "Enjoy the sound!";

    public void init() {
        // Read the file name
        String audioFile = getParameter("audiofile");                 // (1)

        if (audioFile != null) {
            audioClip = getAudioClip(getDocumentBase(), audioFile);   // (2)
            msg = "Enjoy the sound!";
        } else {
            showStatus("Audio file cannot be found.");
            msg = "Enjoy the silence!";
        }
    }

    public void start() {
        // Start the music.
        if (audioClip != null) audioClip.loop();                      // (3)
    }

    public void stop() {     // Stop the music.
        if (audioClip != null) audioClip.stop();                      // (4)
    }

    public void destroy() {  // Clean up.
        audioClip = null;                                             // (5)
    }

    public void paint(Graphics gfx) {
        gfx.translate(getInsets().left, getInsets().top);

        // Display the message.
        gfx.drawString(msg, 50, 50);
    }
}
