
import javax.swing.*;     // Importing the Swing component set.            (1)
import java.awt.*;        // Still use parts of the AWT.
import java.awt.event.*;  // Swing uses the same event model as the AWT.

public class SwingApp {

    public static void main(String args[]) {
        final JFrame appWin = new JFrame("Application using Swing");    // (2)
        // appWin.add( ... ); // Will not work

        // Get the content pane of the root component.
        Container frameContent = appWin.getContentPane();               // (3)

        frameContent.setLayout(new BorderLayout());  // Not needed         (4)

        JButton exitButton = new JButton("Exit");  // Mirrors AWT          (5)
        frameContent.add(exitButton, BorderLayout.SOUTH);

        JComponent complexComponent = new JColorChooser();  // New complex (6)
        frameContent.add(complexComponent, BorderLayout.CENTER);

        // Simple event handling                                           (7)
        exitButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent aEvt) {
                System.exit(0);
            }
        });
        appWin.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent wEvt) {
                System.exit(0);
            }
        });

        appWin.pack(); // Same as for the AWT                             (8)
        appWin.setVisible(true);
    }
}
