import java.io.*;

public class DirectoryLister {
    public static void main(String args[]) {
        File entry;
        if (args.length == 0) {               // (1)
            System.err.println("Please specify a directory name.");
            return;
        }
        entry = new File(args[0]);            // (2) user specified

        listDirectory(entry);
    }

    public static void listDirectory(File entry) {
        try {
            if (!entry.exists()) {                                      // (3)
                System.out.println(entry.getName() + " not found.");
                return;
            }

            if (entry.isFile()) {
                // Write the pathname of the file
                System.out.println(entry.getCanonicalPath());           // (4)
            } else if (entry.isDirectory()) {
                // Create list of entries for this directory
                String[] fileName = entry.list();                       // (5)
                if (fileName == null) return;
                for (int i = 0; i<fileName.length; i++) {
                    // Create a File object for the entry
                    File item = new File(entry.getPath(), fileName[i]); // (6)
                    // List it by a recursive call.
                    listDirectory(item);                                // (7)
                }
            }
        } catch(IOException e) { System.out.println("Error: " + e); }
    }
}
