
/* Copy a file.
   Command syntax: java CopyFile <from-file> <to-file>
*/

import java.io.*;

class CopyFile {
    public static void main(String args[]) {
        FileInputStream fromFile;
        FileOutputStream toFile;

        // Assign the files
        try {
            fromFile = new FileInputStream(args[0]);     // (1)
            toFile = new FileOutputStream(args[1]);      // (2)
        } catch(FileNotFoundException e) {
            System.err.println("File could not be copied: " + e);
            return;
        } catch(IOException e) {
            System.err.println("File could not be copied: " + e);
            return;
        } catch(ArrayIndexOutOfBoundsException e) {
            System.err.println("Usage: CopyFile <from-file> <to-file>");
            return;
        }

        // Copy bytes
        try {                                            // (3)
            int i = fromFile.read();
            while (i != -1) { // check end of file
                toFile.write(i);
                i = fromFile.read();
            }
        } catch(IOException e) {
            System.err.println("Error reading/writing.");
        }

        // Close the files
        try {                                            // (4)
            fromFile.close();
            toFile.close();
        } catch(IOException e) {
            System.err.println("Error closing file.");
        }
    }
}
