
// Reading and Writing Objects
import java.io.*;

public class ObjectSerializationDemo {

    void writeData() {                                    // (1)
        try {
            // Setup the Output stream
            FileOutputStream outputFile = new FileOutputStream("obj-storage.dat");
            ObjectOutputStream outputStream = new ObjectOutputStream(outputFile);

            // Write data
            String[] strArray = {"Seven", "Eight", "Six"};
            long num = 2001;
            int[] intArray = {1, 3, 1949};
            String commonStr = strArray[2];

            outputStream.writeObject(strArray);
            outputStream.writeLong(num);
            outputStream.writeObject(intArray);
            outputStream.writeObject(commonStr);

            // Close the stream
            outputStream.flush();
            outputStream.close();
        } catch (IOException ex) {
            System.err.println(ex);
        }
    }

    void readData() {                                     // (2)
        try {
            // Setup the Input stream
            FileInputStream inputFile = new FileInputStream("obj-storage.dat");
            ObjectInputStream inputStream = new ObjectInputStream(inputFile);

            // Read data
            String[] strArray = (String[]) inputStream.readObject();
            long num = inputStream.readLong();
            int[] intArray = (int[]) inputStream.readObject();
            String commonStr = (String) inputStream.readObject();

            // Write data on standard output stream
            for (int i = 0; i < strArray.length; i++) {
                System.out.print(strArray[i] + "\t");
            }
            System.out.println();
            System.out.println(num);
            for (int i = 0; i < intArray.length; i++) {
                System.out.print(intArray[i] + "\t");
            }
            System.out.println();
            System.out.println(commonStr);

            // Close the stream
            inputStream.close();
        } catch (Exception ex) {
            System.err.println(ex);
        }
    }

    public static void main(String args[]) {
        ObjectSerializationDemo demo = new ObjectSerializationDemo();
        demo.writeData();
        demo.readData();
    }
}
