
abstract class Light {
    // Instance variables
    int noOfWatts;           // wattage
    boolean indicator;       // on or off
    String location;         // placement

    // Instance methods
    public void switchOn()  { indicator = true; }
    public void switchOff() { indicator = false; }
    public boolean isOn()   { return indicator; }

    // Abstract Instance Method
    abstract public double KWHprice();               // (1) No method-body
}

class TubeLight extends Light {
    // Instance variables
    int tubeLength;
    int color;

    // Implementation of inherited abstract method.
    public double KWHprice() { return 2.75; }        // (2)
}

class Factory {
    TubeLight cellarLight = new TubeLight();         // (3) OK.
    Light spotlight;                                 // (4) OK.
//  Light tableLight = new Light();                  // (5) Compile time error.
}
