
// Exceptions
class InvalidHoursException extends Exception {}
class NegativeHoursException extends InvalidHoursException {}
class ZeroHoursException extends InvalidHoursException {}

class Light {

    protected String billType = "Small bill";               // (1)

    protected double getBill(int noOfHours)
              throws InvalidHoursException {                // (2)
        double smallAmount = 10.0,
               smallBill = smallAmount * noOfHours;
        System.out.println(billType + ": " + smallBill);
        return smallBill;
    }

    public void banner() {                                  // (3)
        System.out.println("Let there be light!");
    }
}

class TubeLight extends Light {

    public String billType = "Large bill";                  // (4) Shadowing.

    public double getBill(final int noOfHours)
           throws ZeroHoursException {                      // (5) Overriding.
        double largeAmount = 100.0,
               largeBill = largeAmount * noOfHours;
        System.out.println(billType + ": " + largeBill);
        return largeBill;
    }

    public double getBill() {                               // (6)
        System.out.println("No bill");
        return 0.0;
    }
}

class NeonLight extends TubeLight {
    // ...
    public void demonstrate()
            throws InvalidHoursException {                  // (7)
        super.banner();                                     // (8)
        super.getBill(20);                                  // (9)
        super.getBill();                                    // (10)
        System.out.println(super.billType);                 // (11)
        ((Light) this).getBill(20);                         // (12)
        System.out.println(((Light) this).billType);        // (13)
    }
}

public class Client {
    public static void main(String args[])
                       throws InvalidHoursException {
        NeonLight neonRef = new NeonLight();
        neonRef.demonstrate();
    }
}
