class SuperBlob {                                     // (1)  
    static int idCounter;
    static int population;

    protected int blobId;

    public SuperBlob() {
        blobId = idCounter++;
        ++population;
    }
    protected void finalize() throws Throwable {      // (2)
        super.finalize();
        --population;
    } 
}

class Blob extends SuperBlob {                        // (3)
    int[] fat;

    public Blob(int bloatedness) {                    // (4)
        fat = new int[bloatedness];
        System.out.println(blobId + ": Hello");
    }
    protected void finalize() throws Throwable {      // (5)
        System.out.println(blobId + ": Bye");
        super.finalize();
    }
}

public class Finalizers {
    public static void main(String args[]) {          // (6)
        int blobsRequired, blobSize;
        try {
            blobsRequired = Integer.parseInt(args[0]);
            blobSize      = Integer.parseInt(args[1]);
        } catch(IndexOutOfBoundsException e) {
            System.err.println("Usage: Finalizers <number of blobs> <blob size>");
            return;
        }

        for (int i=0; i<blobsRequired; ++i) {         // (7)
            new Blob(blobSize);
        }
        System.out.println(SuperBlob.population + " blobs alive"); // (8)
    }
}
