
class RoomOccupancyTooHighException
      extends RuntimeException {}                    // (1) Unchecked Exception
class TooManyHotelsException
      extends Exception {}                           // (2) Checked Exception

class Hotel {
    // Static Members
    private static int NO_OF_HOTELS = 12;
    private static Hotel[] hotelPool = creatHotelPool();  // (3)

    private static Hotel[] creatHotelPool() {             // (4)
        try {
             if (NO_OF_HOTELS > 10)
                 throw new TooManyHotelsException();
        } catch (TooManyHotelsException e) {
             NO_OF_HOTELS = 10;
             System.out.println("No. of hotels adjusted to " +
                                 NO_OF_HOTELS);
        }
        return new Hotel[NO_OF_HOTELS];
    }
    // Instance Members
    private int NO_OF_ROOMS = 215;
    private int OCCUPANCY_PER_ROOM = 5;
    private int MAX_NO_OF_GUEST = initMaxGuests();        // (5)

    private int initMaxGuests() {                         // (6)
        if (OCCUPANCY_PER_ROOM > 4)
                 throw new RoomOccupancyTooHighException();
        return NO_OF_ROOMS * OCCUPANCY_PER_ROOM;
    }
}

public class ExceptionsInInitializers {
    public static void main(String args[]) {
        new Hotel();
    }
}
