
class BankrupcyException
      extends RuntimeException {}               // (1) Unchecked Exception
class TooManyHotelsException
      extends Exception {}                      // (2) Checked Exception

class Hotel {
    // Static Members
    private static boolean BANKRUPT = true;
    private static int NO_OF_HOTELS = 11;
    private static Hotel[] hotelPool;

    static {                                    // (3) Static block
        if (BANKRUPT)
            throw new BankrupcyException();     // (4) Throws unchecked exception
    }

    static {                                    // (5) Static block
        try {                                   // (6) Handles checked exception
             if (NO_OF_HOTELS > 10)
                 throw new TooManyHotelsException();
        } catch (TooManyHotelsException e) {
             NO_OF_HOTELS = 10;
             System.out.println("No. of hotels adjusted to " +
                                 NO_OF_HOTELS);
        }
        hotelPool = new Hotel[NO_OF_HOTELS];
    }
    // ...
}

public class ExceptionInStaticInitBlocks {
    public static void main(String args[]) {
        new Hotel();
    }
}
