
class RoomOccupancyTooHighException
      extends Exception {}                      // (1) Checked Exception
class BankrupcyException
      extends RuntimeException {}               // (2) Unchecked Exception

class Hotel {
    // Instance Members
    private static boolean BANKRUPT = true;
    private int NO_OF_ROOMS = 215;
    private int OCCUPANCY_PER_ROOM = 5;
    private int MAX_NO_OF_GUEST;

    {                                           // (3) Instance initializer block
        if (BANKRUPT)
            throw new BankrupcyException();     // (4) Throws unchecked exception
    }

    {                                           // (5) Instance block
        try {
             if (OCCUPANCY_PER_ROOM > 4)        // (6) Handles checked exception
                 throw new RoomOccupancyTooHighException();
        } catch (RoomOccupancyTooHighException e) {
             System.out.println("ROOM OCCUPANCY TOO HIGH: " + OCCUPANCY_PER_ROOM);
             OCCUPANCY_PER_ROOM = 4;
        }
        MAX_NO_OF_GUEST = NO_OF_ROOMS * OCCUPANCY_PER_ROOM;
    }
    // ...
}

public class ExceptionsInInstBlocks {
    public static void main(String args[]) {
        new Hotel();
    }
}
