
class Counter implements Runnable {

    private int currentValue;

    private Thread worker;

    public Counter(String threadName) {
        currentValue = 0;
        worker = new Thread(this, threadName);   // (1) Create a new thread
        System.out.println(worker);
        worker.start();                          // (2) Start the thread
    }

    public void run() {                          // (3) Thread entry point
        try {
            while (currentValue < 5) {
                System.out.println(worker.getName() + ": " + (currentValue++));
                Thread.sleep(500);               // (4) Current thread sleeps
            }
        } catch (InterruptedException e) {
            System.out.println(worker.getName() + " interrupted.");
        }
        System.out.println("Exit from " + worker.getName() + ".");
    }

    public int getValue() { return currentValue; }
}

public class Client {
    public static void main(String args[]) {
        Counter counterA = new Counter("Counter A"); // (5) Create a thread

        try {
            int val;
            do {
                val = counterA.getValue();       // (6) Access the counter value
                System.out.println("Main Thread: " + val);
                Thread.sleep(1000);              // (7) Current thread sleeps
            } while (val < 5);
        } catch (InterruptedException e) {
            System.out.println("Main Thread interrupted.");
        }

        System.out.println("Exit from Main Thread.");
    }
}
