class Counter extends Thread {

    private int currentValue;

    public Counter(String threadName) {
        super(threadName);                       // (1) Initialize thread
        currentValue = 0;
        System.out.println(this);
        start();                                 // (2) Start this thread
    }

    public void run() {                          // (3) Override from superclass
        try {
            while (currentValue < 5) {
                System.out.println(getName() + ": " + (currentValue++));
                Thread.sleep(500);               // (4) Current thread sleeps
            }
        } catch (InterruptedException e) {
            System.out.println(getName() + " interrupted.");
        }
        System.out.println("Exit from " + getName() + ".");
    }

    public int getValue() { return currentValue; }
}

public class AnotherClient {
    public static void main(String args[]) {

        Counter cA = new Counter("Counter A");
        Counter cB = new Counter("Counter B");

        try {
            System.out.println("Wait for the child threads to finish.");
            cA.join();                                       // (5)
            cB.join();                                       // (6)

            if (!cA.isAlive())                               // (7)
                System.out.println("Counter A not alive.");
            if (!cB.isAlive())                               // (8)
                System.out.println("Counter B not alive.");
        } catch (InterruptedException e) {
            System.out.println("Main Thread interrupted.");
        }
        System.out.println("Exit from Main Thread.");
    }
}
