// Filename: CatchMe.java
import java.awt.event.*;
import java.awt.*;

public class CatchMe {
    Panel playPanel;
    Button wildButton;
    Point placement;

    public static void main(String args[]) {
        new CatchMe();
    }

    CatchMe() {
        Window window = new Frame("Try pressing the button");
        playPanel  = new Panel();
        wildButton = new Button("Click me");

        window.add(playPanel, BorderLayout.CENTER);

        playPanel.setLayout(null);
        playPanel.add(wildButton);

        window.setSize(400, 300);
        window.setVisible(true);

        Dimension buttonSize = wildButton.getPreferredSize();
        wildButton.setSize(buttonSize);

        placeButton();
        playPanel.addMouseMotionListener(new ButtonMover());
        wildButton.addActionListener(new CaughtListener());

        window.addWindowListener(
            new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    System.exit(0);
                }
            }
        );
    }

    class ButtonMover extends MouseMotionAdapter {
        public void mouseMoved(MouseEvent mouseEvent) {
            int xd = Math.abs(placement.x - mouseEvent.getX());
            int yd = Math.abs(placement.y - mouseEvent.getY());

            Dimension buttonSize = wildButton.getSize();
            if ((xd < buttonSize.width) && (yd < buttonSize.height))
                placeButton();
        }
    }

    class CaughtListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            wildButton.setLabel("Congratulations!");
            wildButton.setSize(wildButton.getPreferredSize());
            placeButton();
        }
    }

    void placeButton() {
        Dimension playRegion = playPanel.getSize();
        Dimension buttonSize = wildButton.getSize();
        int xSpan = playRegion.width  - buttonSize.width;
        int ySpan = playRegion.height - buttonSize.height;

        int x = (int) (Math.random() * xSpan);
        int y = (int) (Math.random() * ySpan);

        wildButton.setLocation(x, y);
        placement = new Point(x + buttonSize.width/2, y + buttonSize.height/2);
        playPanel.validate();
    }
}
