// Filename: IGeometryConstants.java

/**
 * Contains a set of constants that are used by other classes.
 * Contains a shape type enumeration and a size enumeration, and arrays
 * of strings associating the enumeration values with textual labels.
 */
interface IGeometryConstants {                                    // (1)
    int SQUARE  = 0;
    int CIRCLE  = 1;
    int ELLIPSE = 2;
    String[] shapeNames = {"Square", "Circle", "Ellipse"};

    int SMALL  = 0;
    int MEDIUM = 1;
    int LARGE  = 2;
    String[] sizeNames = {"Small", "Medium", "Large"};
}
